#include "Common.h"
#include "A0.h"

///////////////////////////////////////////////////////////////
//   A0

void A0_Step(int e)
{
    switch (A0_y)
    {
        case 0: // C 
            if (e==A0_e0) {
                // WriteLog("   0  e0",0);
		        A1_Step(e);
	            A2_Step(e);
                A0_z1_0();
                A0_z2_0();
                A0_z3_0();
            } else
            if (e==A0_e2) {
                // WriteLog("   0  e2",0);
                A0_z4_0(TAFTERREST);
				A0_z3_1();
                A0_z5_0();
				A0_y=1;
            } else
            if (!A0_x1_0()) {
				A0_z3_2();
				A0_y=1;
			}
        break;
        case 1: //  
			A0_z5_2();
			if (A0_x5_0()&&A0_x3_0()) {
				A0_y=0;
			} else
			if (A0_x5_0()&&!A0_x3_0()&&A0_x1_0()) {
				A0_z3_0();
				A0_y=0;
			} else
			if (!A0_x4_0()) {
				A0_z4_1();
			} else
			if (A0_x2_0()) {				
				A0_z5_1();
				A0_y=2;
			} else
			if (A0_x3_1()) {
				A1_Step(A1_e2);
				A0_z1_1();
				A0_z5_3();
				A0_y=3;
			} else
			if (A0_x3_2()) {
				A1_Step(A1_e2);
				A0_z1_2();
				A0_z5_3();
				A0_y=4;
			}
        break;
        case 2: //   
			A2_Step(e);
			A0_z5_2();
			if (A2_y==0) {
				A0_z4_0(0);
				A0_z3_1();
				A0_z2_1();
				A0_y=1;
			}
        break;
		case 3: // 
			A1_Step(e);
			if (A1_y==0&&(A0_x2_0()||(A0_x5_0()&&A0_x1_0()))) {
				A0_z4_0(TUPBRAKING);
				A0_y=1;
			} else
			if (A1_y==0&&!A0_x2_0()) {
				A0_z1_1();
			}
		break;
        case 4: // 
			A1_Step(e);
			if (A1_y==0&&(A0_x2_0()||(A0_x5_0()&&A0_x1_0()))) {
				A0_z4_0(TDOWNBRAKING);
				A0_y=1;
			} else
			if (A1_y==0&&!A0_x2_0()) {
				A0_z1_2();
			}
        break;
    }
}

///////////////////////////////////////////////////////////////
//  

// ,    

int A0_x1_0()
{
    return (floor==2);
}

// ,    

int A0_x2_0()
{
	StateValues st=A0_t3_0();
    return (((st!=GOINGDOWN)&(calls.up[floor]!=0))|((st!=GOINGUP)&(calls.down[floor]!=0))|(calls.car[floor]!=0));
}

// ,    

int A0_x3_0()
{
    return (state==NEUTRAL);
}

int A0_x3_1()
{
    return (state==GOINGUP);
}

int A0_x3_2()
{
    return (state==GOINGDOWN);
}

// ,   

int A0_x4_0()
{
	return (timer==0);
}

// ,    

int A0_x5_0()
{
	return (inactivitytimer==0);
}

///////////////////////////////////////////////////////////////
//  

//   

void A0_z1_0()
{
    // WriteLog(" z1_0",1);
    floor=2;
}

void A0_z1_1()
{
    // WriteLog(" z1_1",1);
    floor++;
}

void A0_z1_2()
{
    // WriteLog(" z1_2",1);
    floor--;
}

//    

void A0_z2_0()
{
    // WriteLog(" z2_0",1);
	int i;
    for (i=0; i<5; i++) {
        calls.car[i]=0;
        calls.up[i]=0;
        calls.down[i]=0;
    }
}

void A0_z2_1()
{
    // WriteLog(" z2_1",1);
	calls.car[floor]=0;
	if (state!=GOINGDOWN) calls.up[floor]=0;
	if (state!=GOINGUP) calls.down[floor]=0;
}

//    

void A0_z3_0()
{
    // WriteLog(" z3_0",1);
    state=NEUTRAL;
}

void A0_z3_1()
{
	// WriteLog(" z3_1",1);
	state=A0_t3_0();
}

void A0_z3_2()
{
    // WriteLog(" z3_2",1);
	state=((int)floor>2?GOINGDOWN:GOINGUP);
	if ((int)floor==2) state=NEUTRAL;
}

//   

void A0_z4_0(unsigned n)
{
    // CString str; str.Format(" z4_0(%d)",n); WriteLog(str,1);
	timer=n;
}

void A0_z4_1()
{
    // WriteLog(" z4_1",1);
	if (timer>0) timer--;
}

//    

void A0_z5_0()
{
    // WriteLog(" z5_0",1);
	inactivitytimer=-1;
}

void A0_z5_1()
{
    // WriteLog(" z5_1",1);
	inactivitytimer=TINACTIVE;
}

void A0_z5_2()
{
    // WriteLog(" z5_2",1);
	if (inactivitytimer>0 && state==NEUTRAL) inactivitytimer--;
}

void A0_z5_3()
{
    // WriteLog(" z5_3",1);
	if (!A0_x5_0()) A0_z5_0();
}

///////////////////////////////////////////////////////////////
//  

// ,    

StateValues A0_t3_0()
{
	int i;
	switch (state)
	{
		case GOINGUP:
			if (calls.up[floor]!=0) return GOINGUP;
			for (i=floor+1; i<=5; i++)
			{
				if (i==5) break;
				if (calls.car[i]!=0 || calls.up[i]!=0 || calls.down[i]!=0) break;
			}
			if (i==5)
			{
				bool r=false;
				for (i=0; i<=(int)floor-1; i++) r|=((calls.car[i]!=0)|(calls.up[i]!=0)|(calls.down[i]!=0));
				if (r) state=GOINGDOWN; else if (!A0_x5_0()) state=NEUTRAL;
			}
		break;

		case GOINGDOWN:
			if (calls.down[floor]!=0) return GOINGDOWN;
			for (i=floor-1; i>=-1; i--)
			{
				if (i==-1) break;
				if (calls.car[i]!=0 || calls.up[i]!=0 || calls.down[i]!=0) break;
			}
			if (i==-1)
			{
				bool r=false;
				for (i=floor+1; i<=4; i++) r|=((calls.car[i]!=0)|(calls.up[i]!=0)|(calls.down[i]!=0));
				if (r) state=GOINGUP; else if (!A0_x5_0()) state=NEUTRAL;
			}
		break;

		case NEUTRAL:
			if (calls.up[floor]!=0||calls.down[floor]!=0) return NEUTRAL;
			for (i=0; i<=5; i++)
			{
				if (i==5) break;
				if (calls.car[i]!=0 || calls.up[i]!=0 || calls.down[i]!=0) break;
			}
			if (i==5 || i==(int)floor) return NEUTRAL;
			state=((int)floor>i?GOINGDOWN:GOINGUP);
		break;
	}
	return state;
}
